using System;
using System.Collections.Generic;
using jp.netgamers.free.tuogl;	//	OpenGL ̔bp[ڎwĂ
using jp.netgamers.free.tugame;	//	OpenGL ̃CuڎwĂ

class MyModel
{
	public static String[]	Name = { "Akichi", "Building","Hatake","House","Azemichi","Jisya","Platform","Ekisya", "Rail","Train", "House3", "House2", "House1", "House5", "Cursor", "Sea" };
	public static Dictionary<String, TUPrimitive>	Pri = new Dictionary<String, TUPrimitive>();
	public static Dictionary<String, TUElements>	mTUE = new Dictionary<String, TUElements>();

	public static void load()
	{
		foreach( String s in Name ){
			mTUE[ s ] = new TUElements( TUPrimitive.readAssets( s ) );
		}

		Pri[ "Rail_0a" ] = TUPrimitive.readAssets( "Rail" );
		Pri[ "Rail_0b" ] = TUPrimitive.readAssets( "Rail" );
		Pri[ "Rail_1a" ] = TUPrimitive.readAssets( "Rail" );
		Pri[ "Rail_1b" ] = TUPrimitive.readAssets( "Rail" );
		Pri[ "Rail_2a" ] = TUPrimitive.readAssets( "Rail" );
		Pri[ "Rail_2b" ] = TUPrimitive.readAssets( "Rail" );
		Pri[ "Rail_3a" ] = TUPrimitive.readAssets( "Rail" );
		Pri[ "Rail_3b" ] = TUPrimitive.readAssets( "Rail" );

		Pri[ "Rail_1a" ].scale( 1.42f, 1.0f, 1.0f );
		Pri[ "Rail_1b" ].scale( 1.42f, 1.0f, 1.0f );
		Pri[ "Rail_2a" ].scale( 1.25f, 1.0f, 1.0f );
		Pri[ "Rail_2b" ].scale( 1.1f , 1.0f, 1.0f );
		Pri[ "Rail_3a" ].scale( 1.25f, 1.0f, 1.0f );
		Pri[ "Rail_3b" ].scale( 1.1f , 1.0f, 1.0f );

		Pri[ "Rail_0a" ].translate(   0, -11, 0 );
		Pri[ "Rail_0b" ].translate(   0,  11, 0 );
		Pri[ "Rail_1a" ].translate(   8,  12, 0 );
		Pri[ "Rail_1b" ].translate(  11,  33, 0 );
		Pri[ "Rail_2a" ].translate(   0, -11, 0 );
		Pri[ "Rail_2b" ].translate(   0,  11, 0 );
		Pri[ "Rail_3a" ].translate(  -8,  12, 0 );
		Pri[ "Rail_3b" ].translate( -11,  33, 0 );

		mTUE[ "Rail_0" ] = new TUElements();
		mTUE[ "Rail_1" ] = new TUElements();
		mTUE[ "Rail_2" ] = new TUElements();
		mTUE[ "Rail_3" ] = new TUElements();

		mTUE[ "Rail_0" ].add( Pri[ "Rail_0a" ] );
		mTUE[ "Rail_0" ].add( Pri[ "Rail_0b" ] );
		mTUE[ "Rail_1" ].add( Pri[ "Rail_1a" ] );
		mTUE[ "Rail_1" ].add( Pri[ "Rail_1b" ] );
		mTUE[ "Rail_2" ].add( Pri[ "Rail_2a" ] );
		mTUE[ "Rail_2" ].add( Pri[ "Rail_2b" ] );
		mTUE[ "Rail_3" ].add( Pri[ "Rail_3a" ] );
		mTUE[ "Rail_3" ].add( Pri[ "Rail_3b" ] );
	}

	public static void drawRail( int x, int y, int a )
	{
		if( a % 4 == 0 ){	//	90xP
//			Pri[ "Rail_0a" ].draw( x, y, 0, a * 22.5f, 0, 0, 1 );
//			Pri[ "Rail_0b" ].draw( x, y, 0, a * 22.5f, 0, 0, 1 );
			mTUE[ "Rail_0" ].draw( x, y, 0, a * 22.5f, 0, 0, 1 );
			return;
		}

		if( a % 2 == 0 ){	//	45xP
//			Pri[ "Rail_2a" ].draw( x, y, 0, a * 22.5f, 0, 0, 1 );
//			Pri[ "Rail_2b" ].draw( x, y, 0, a * 22.5f, 0, 0, 1 );
			mTUE[ "Rail_2" ].draw( x, y, 0, a * 22.5f, 0, 0, 1 );
			return;
		}

		if( a % 4 == 1 ){	//	22.5 + 90n xP
//			Pri[ "Rail_1a" ].draw( x, y, 0, a * 22.5f + 3.9f, 0, 0, 1 );
//			Pri[ "Rail_1b" ].draw( x, y, 0, a * 22.5f + 4.0f, 0, 0, 1 );
			mTUE[ "Rail_1" ].draw( x, y, 0, a * 22.5f + 4.0f, 0, 0, 1 );
			return;
		}

//		Pri[ "Rail_3a" ].draw( x, y, 0, a * 22.5f - 3.9f, 0, 0, 1 );
//		Pri[ "Rail_3b" ].draw( x, y, 0, a * 22.5f - 4.0f, 0, 0, 1 );
		mTUE[ "Rail_3" ].draw( x, y, 0, a * 22.5f - 4.0f, 0, 0, 1 );
	}

	public static void drawRail( int[] xyta )
	{
		if( xyta == null ){
			return;
		}

		for( int i = 0; i < xyta.Length; i += 4 ){
			drawRail( xyta[ i + 0 ] * 100,
			          xyta[ i + 1 ] * 100,
			          xyta[ i + 3 ] );
		}
	}
}

class MyMap
{
	public static readonly sbyte AKICHI		= 0;
	public static readonly sbyte BUILDING	= 1;
	public static readonly sbyte HATAKE		= 2;
	public static readonly sbyte HOUSE		= 3;
	public static readonly sbyte AZEMICHI	= 4;
	public static readonly sbyte JISYA		= 5;
	public static readonly sbyte PLATFORM	= 6;
	public static readonly sbyte EKISYA		= 7;
	public static readonly sbyte RAIL		= 8;
	public static readonly sbyte TRAIN		= 9;
	public static readonly sbyte HOUSE3		= 10;
	public static readonly sbyte HOUSE2		= 11;
	public static readonly sbyte HOUSE1		= 12;
	public static readonly sbyte HOUSE5		= 13;
	public static readonly sbyte POINT		= 14;	//	

	public static int		Width, Height;
	public static sbyte[]	Data;
	public static sbyte[]	Angle;
	public static short[]	Prm;

	public static int[] createRail( int sx, int sy, int ex, int ey )
	{
		int		dx = ex - sx;
		int		dy = ey - sy;
		int		lx = Math.Abs( dx );
		int		ly = Math.Abs( dy );
		int		len;
		if( lx < ly ){
			len = ly;
		}else{
			len = lx;
		}

		int[]	r = new int[ ( len + 2 ) * 4 ];
		r[ len * 4 + 4 ] = -1;
		int		a = TULib.getAngle16i( dx, dy );
		int		t = getType( sx, sy );

		if( t == RAIL ){
			int		b = getAngle( sx, sy );
			int		d0 = diffAngle16( a, b );
			int		d1 = diffAngle16( a, b ^ 8 );
			bool	rev = false;
			if( Math.Abs( d0 ) < Math.Abs( d1 ) ){
				a = b;
			}else{
				a = b ^ 8;
				d0 = d1;
				rev = true;
			}
			if( isRail( sx + getNextRailX( a, rev ), sy + getNextRailY( a, rev ) ) ){
				a += d0 < 0 ? 1 : -1;
				a &= 15;
			}
		}

		r[ 0 ] = sx;
		r[ 1 ] = sy;
		r[ 2 ] = RAIL;
		r[ 3 ] = a;

		if( t == PLATFORM ){
			a = r[ 3 ] = getAngle( sx, sy );
			r[ 2 ] = PLATFORM;
		}

		sx *= 2;
		sy *= 2;
		dx *= 2;
		dy *= 2;
		sx++;
		sy++;
		sx += Math.Sign( getRailDX( a ) );
		sy += Math.Sign( getRailDY( a ) );
		dx -= Math.Sign( getRailDX( a ) );
		dy -= Math.Sign( getRailDY( a ) );

		if( ( a & 3 ) == 3 ){
			r[ 3 ] ^= 8;
		}

		for( int i = 1; i <= len; i++ ){
			a = TULib.getAngle16i( dx, dy );
			int		b = (int)TULib.getAngle360( dx, dy ) % 180;
			int		c = a & 7;

			if( ( sx & 1 ) == 0 && c == 4 ){
				a += b > 90 ? 1 : -1;
			}

			if( ( sy & 1 ) == 0 && c == 0 ){
				a += b < 90 ? 1 : -1;
			}

			if( ( sx & 1 ) == 1 ){
				if( c < 3 ){
					a += 3 - c;
				}
				if( c > 5 ){
					a -= c - 5;
				}
			}
			if( ( sy & 1 ) == 1 ){
				if( c == 2 || c == 3 ){
					a -= c - 1;
				}if( c == 5 || c == 6 ){
					a += 7 - c;
				}
			}
			a &= 15;

			int		ax = getRailDX( a );
			int		ay = getRailDY( a );

			c = a & 7;
			if( ( c == 1 && ( sy & 1 ) == 0 ) ||
			    ( c == 3 && ( sx & 1 ) == 1 ) ||
			    ( c == 5 && ( sx & 1 ) == 0 ) ||
			    ( c == 7 && ( sy & 1 ) == 1 ) ){
				a ^= 8;
			}

			r[ i * 4 + 0 ] = (int)( ( sx + ax / 2.0f ) / 2 );
			r[ i * 4 + 1 ] = (int)( ( sy + ay / 2.0f ) / 2 );
			r[ i * 4 + 2 ] = RAIL;
			r[ i * 4 + 3 ] = a;

			t = getType( r[ i * 4 ], r[ i * 4 + 1 ] );
			if( t == PLATFORM || t == EKISYA || t == POINT ){
				r[ i * 4 + 4 ] = -2;
				r[ len * 4 + 4 ] = -2;
				return( r );
			}
			if( t == RAIL ){
				r[ i * 4 + 4 ] = -2;
				if( Math.Abs( diffAngle8( a, getAngle( r[ i * 4 ], r[ i * 4 + 1 ] ) ) ) > 1 ){
					r[ len * 4 + 4 ] = -2;
				}
				return( r );
			}

			sx += ax;
			sy += ay;
			dx -= ax;
			dy -= ay;
		}

		return( r );
	}

	public static int diffAngle8( int a )
	{
		if( a >= 4 )	a -= 8;
		if( a < -4 )	a += 8;
		return( a );
	}

	public static int diffAngle8( int a, int b )
	{
		return( diffAngle8( diffAngle16( a, b ) ) );
	}

	public static int diffAngle16( int a, int b )
	{
		int		r = b - a;
		if( r >= 8 )	r -= 16;
		if( r < -8 )	r += 16;
		return( r );
	}

	public static void draw( int cx, int cy, int size )
	{
		for( int my = cy - size; my <= cy + size; my++ ){
			for( int mx = cx - size; mx <= cx + size; mx++ ){
				int		x = mx * 100;
				int		y = my * 100;
				if( !isRegion( mx, my ) ){
					MyModel.mTUE[ "Sea" ].draw( x, y, 0 );
					continue;
				}
				int		a = getAngle( mx, my );
				int		t = getType( mx, my );
				if( t < 0 ){
					continue;
				}
				if( t == RAIL ){
					MyModel.mTUE[ "Jisya" ].draw( x, y, 0 );
					MyModel.drawRail( x, y, a );	//	[`
					continue;
				}
				if( t == POINT ){
					MyModel.mTUE[ "Jisya" ].draw( x, y, 0 );
					MyModel.drawRail( x, y, a );		//	[`
					MyModel.drawRail( x, y, a + 1 );	//	[`
					continue;
				}
				if( t == PLATFORM ){
					MyModel.mTUE[ "Platform" ].draw( x, y, 0, a * 22.5f, 0, 0, 1 );
					MyModel.drawRail( x, y, a );	//	[`
					continue;
				}
				if( isTwice( t ) ){
					MyModel.mTUE[ MyModel.Name[ t ] ].draw( x + 50, y + 50, 0, a * 22.5f, 0, 0, 1 );
					continue;
				}
				MyModel.mTUE[ MyModel.Name[ t ] ].draw( x, y, 0, a * 22.5f, 0, 0, 1 );
			}
		}
	}

	public static int getNextRailX( int a, bool rev )
	{
		if( rev ){
			if( a >= 6 && a <= 11 )	return( 1 );
			if( a >= 4 && a <= 13 )	return( 0 );
			return( -1 );
		}
		if( a >= 5 && a <= 10 )	return( -1 );
		if( a >= 3 && a <= 12 )	return(  0 );
		return( 1 );
	}

	public static int getNextRailX( int a, bool rev, bool pl )
	{
		if( pl ){
			a++;
			a &= 15;
		}
		return( getNextRailX( a, rev ) );
	}

	public static int getNextRailY( int a, bool rev )
	{
		if( rev ){
			if( a >= 2 && a <=  7 )	return( -1 );
			if( a >= 10           )	return(  1 );
			return( 0 );
		}

		if( a >= 1 && a <=  6 )	return(  1 );
		if( a >= 9 && a <= 14 )	return( -1 );
		return( 0 );
	}

	public static int getNextRailY( int a, bool rev, bool pl )
	{
		if( pl ){
			a++;
			a &= 15;
		}
		return( getNextRailY( a, rev ) );
	}

	//	@param	di	_Cԍ
	public static bool getPointLeft( int mx, int my, int di )
	{
		if( getType( mx, my ) != POINT ){
			return( false );
		}

		return( false );	//	TODO	_Cԍɂĕς
	}

	public static int getRailDX( int a )
	{
		if( a <= 2 || a >= 14 )	return(  2 );
		if( a == 3 || a == 13 )	return(  1 );
		if( a == 4 || a == 12 )	return(  0 );
		if( a == 5 || a == 11 )	return( -1 );
		return( -2 );
	}

	public static int getRailDX( int a, bool rev )
	{
		if( rev ){
			a ^= 8;
		}
		return( getRailDX( a ) );
	}

	public static int getRailDX( int a, bool rev, bool pl )
	{
		if( pl ){
			a++;
			a &= 15;
		}
		return( getRailDX( a, rev ) );
	}

	public static int getRailDY( int a )
	{
		if( a == 9 || a == 15 )	return( -1 );
		if( a == 0 || a ==  8 )	return(  0 );
		if( a == 1 || a ==  7 )	return(  1 );
		if( a <= 6            )	return(  2 );
		return( -2 );
	}

	public static int getRailDY( int a, bool rev )
	{
		if( rev ){
			a ^= 8;
		}
		return( getRailDY( a ) );
	}

	public static int getRailDY( int a, bool rev, bool pl )
	{
		if( pl ){
			a++;
			a &= 15;
		}
		return( getRailDY( a, rev ) );
	}

	public static int getAngle( int mx, int my )
	{
		return( Angle[ my * Width + mx ] );
	}

	public static int getPointAngle( int a, int b )
	{
		if( Math.Abs( diffAngle16( a, b ) ) != 1 ){
			if( ( a & 1 ) == 0 ){
				a ^= 8;
			}else{
				b ^= 8;
			}
		}

		return( diffAngle16( a, b ) == 1 ? a : b );
	}

	public static int getType( int mx, int my )
	{
		if( !isRegion( mx, my ) ){
			return( -1 );
		}
		return( Data[ my * Width + mx ] );
	}

	public static short getPrm( int mx, int my )
	{
		if( !isRegion( mx, my ) ){
			return( -1 );
		}
		return( Prm[ my * Width + mx ] );
	}

	public static void init( int width, int height )
	{
		Width = width;
		Height = height;

		Data = new sbyte[ Width * Height ];
		Angle = new sbyte[ Width * Height ];
		Prm = new short[ Width * Height ];

		for( int i = 0; i < 10000; i++ ){
			MyMap.set( TUGame.rnd( Width ), TUGame.rnd( Height ), BUILDING, 0 );
		}

		for( int i = 0; i < 1000000; i++ ){
			MyMap.set( TUGame.rnd( Width ), TUGame.rnd( Height ), HATAKE, 0 );
		}

		for( int i = 0; i < 100000; i++ ){
			MyMap.set( TUGame.rnd( Width ), TUGame.rnd( Height ), HOUSE5, 0 );
		}

		for( int i = 0; i < 100000; i++ ){
			MyMap.set( TUGame.rnd( Width ), TUGame.rnd( Height ), HOUSE, 0 );
		}

		for( int i = 0; i < 100000; i++ ){
			MyMap.set( TUGame.rnd( Width ), TUGame.rnd( Height ), HOUSE3, 0 );
		}

		for( int i = 0; i < 100000; i++ ){
			MyMap.set( TUGame.rnd( Width ), TUGame.rnd( Height ), HOUSE2, 0 );
		}

		for( int i = 0; i < 100000; i++ ){
			MyMap.set( TUGame.rnd( Width ), TUGame.rnd( Height ), HOUSE1, 0 );
		}

		for( int y = 0; y < Height; y++ ){
			MyMap.set( 16, y, AZEMICHI, 4 );
		}

		for( int x = 0; x < Width; x++ ){
			MyMap.set( x, 16, RAIL, 0 );
		}
	}

	public static void del( int mx, int my )
	{
		int		t = getType( mx, my );
		if( t == -1 ){
			del( mx - 1, my );
			return;
		}
		if( t == -2 ){
			del( mx, my - 1 );
			return;
		}
		if( !isTwice( t ) ){
			return;
		}

		setType( mx    , my    , HATAKE );
		setType( mx + 1, my    , HATAKE );
		setType( mx    , my + 1, HATAKE );
		setType( mx + 1, my + 1, HATAKE );
	}

	public static float getRailLength( int a )
	{
		if( ( a & 3 ) == 0 )	return( 100.0f );
		if( ( a & 1 ) == 0 )	return( 141.4214f );
		return( 111.8034f );
	}

	public static float getRailLength( int a, bool pl )
	{
		if( pl ){
			a++;
			a &= 15;
		}
		return( getRailLength( a ) );
	}

	public static int getRailGX( int mx, int my, bool rev, bool pl )
	{
		return( mx * 2 + getNextRailX( getAngle( mx, my ), rev, pl ) );
	}

	public static int getRailGY( int mx, int my, bool rev, bool pl )
	{
		return( my * 2 + getNextRailY( getAngle( mx, my ), rev, pl ) );
	}

	public static float getRailX( int mx, int my, bool rev, bool pl, float pos )
	{
		int		a = getAngle( mx, my );
		return( getRailGX( mx, my, rev, pl ) * 50 - getRailDX( a, rev, pl ) * 50 * pos / getRailLength( a, pl ) );
	}

	public static float getRailY( int mx, int my, bool rev, bool pl, float pos )
	{
		int		a = getAngle( mx, my );
		return( getRailGY( mx, my, rev, pl ) * 50 - getRailDY( a, rev, pl ) * 50 * pos / getRailLength( a, pl ) );
	}

	public static bool isRail( int mx, int my )
	{
		int		t = getType( mx, my );
		return( t == RAIL || t == POINT || t == PLATFORM );
	}

	public static bool isRegion( int mx, int my )
	{
		return( mx >= 0 && mx < Width &&
		        my >= 0 && my < Height );
	}

	public static bool isTwice( int t )
	{
		return( t == HOUSE  ||
		        t == HOUSE1 ||
		        t == HOUSE2 ||
		        t == HOUSE3 ||
		        t == HOUSE5 ||
		        t == BUILDING );
	}

	public static bool set( int mx, int my, sbyte t, sbyte a )
	{
		if( !isRegion( mx, my ) ){
			return( false );
		}
		del( mx, my );
		setType( mx, my, t );
		MyMap.Angle[ my * Width + mx ] = a;
		if( isTwice( t ) ){
			set( mx + 1, my    , -1, 0 );
			set( mx    , my + 1, -2, 0 );
			set( mx + 1, my + 1, -2, 0 );
		}
		return( true );
	}

	public static int set( int[] xyta )
	{
		for( int i = 0; i < xyta.Length; i += 4 ){
			if( !set( xyta[ i ], xyta[ i + 1 ], (sbyte)xyta[ i + 2 ], (sbyte)xyta[ i + 3 ] ) ){
				return( i / 4 );
			}
		}
		return( xyta.Length / 4 );
	}

	public static int setRail( int[] xyta )
	{
		for( int i = 0; i < xyta.Length; i += 4 ){
			if( !isRegion( xyta[ i ], xyta[ i + 1 ] ) ){
				break;
			}
			if( getType( xyta[ i ], xyta[ i + 1 ] ) != RAIL ){
				continue;
			}

			int		a = getAngle( xyta[ i ], xyta[ i + 1 ] );
			if( Math.Abs( diffAngle8( a, xyta[ i + 3 ] ) ) != 1 ){
				continue;
			}
			xyta[ i + 2 ] = POINT;
			xyta[ i + 3 ] = getPointAngle( a, xyta[ i + 3 ] );
		}

		return( set( xyta ) );
	}

	public static bool setPrm( int mx, int my, short p )
	{
		if( !isRegion( mx, my ) ){
			return( false );
		}
		Prm[ my * Width + mx ] = p;
		return( true );
	}

	public static bool setType( int mx, int my, sbyte t )
	{
		if( !isRegion( mx, my ) ){
			return( false );
		}
		Data[ my * Width + mx ] = t;
		return( true );
	}

	public static void constructPlatform( int mx, int my, int n )
	{
		int		a = findRail( mx, my );
		int		b = ( a + 4 ) & 15;
		mx += getNextRailX( b, false ) * ( n + 1 );
		my += getNextRailY( b, false ) * ( n + 1 );
		a ^= ( n & 1 ) << 3;
		int		dx = getNextRailX( a, false );
		int		dy = getNextRailY( a, false );
		for( int i = -3; i <= 3; i++ ){
			set( mx + dx * i, my + dy * i, PLATFORM, (sbyte)a );
		}
	}

	public static sbyte findRail( int mx, int my )
	{
		if( isRail( mx    , my + 1 ) )	return(  0 );
		if( isRail( mx - 1, my     ) )	return(  4 );
		if( isRail( mx    , my - 1 ) )	return(  8 );
		if( isRail( mx + 1, my     ) )	return( 12 );
		return( -1 );
	}
}


class Station
{
	public static List<Station>	mObj = new List<Station>();

	int			mMX, mMY;
	sbyte		mAngle;
	ushort		mLine;

	public Station( int mx, int my, sbyte a )
	{
		mMX = mx;
		mMY = my;
		mAngle = a;
		MyMap.set( mMX, mMY, MyMap.EKISYA, mAngle );
		MyMap.setPrm( mMX, mMY, (short)mObj.Count );
		mObj.Add( this );
	}

	public static void add( int mx, int my )
	{
		sbyte	a = MyMap.findRail( mx, my );
		if( a < 0 ){
			return;
		}
		( new Station( mx, my, a ) ).addPlatform();
	}

	public void addPlatform()
	{
		MyMap.constructPlatform( mMX, mMY, mLine++ );
	}
}


class Train
{
	public static List<Train>	Obj = new List<Train>();

	public short		Idx;	//	Ԕԍ
	public int			Length;	//	ԗ
	public float		Speed = 2.0f;

	public int[]		X;	//	bVWX
	public int[]		Y;	//	bVWY
	public float[]		Position;	//	bVł̈ʒu
	public bool[]		Reverse;	//	]

	public Train( int len )
	{
		Idx = (short)Obj.Count;
		Length = len;

		X = new int[ len * 2 ];
		Y = new int[ len * 2 ];
		Position = new float[ len * 2 ];
		Reverse = new bool[ len * 2 ];
	}

	public static bool deploy( int mx, int my )
	{
		if( !MyMap.isRail( mx, my ) ){
			return( false );
		}

		Train t = new Train( 12 );
		Obj.Add( t );

		for( int i = 0, p = 0; i < t.Length; i++ ){
			t.X[ i * 2 ] = mx;
			t.Y[ i * 2 ] = my;
			t.Position[ i * 2 ] = p;
			p += 138;

			t.X[ i * 2 + 1 ] = mx;
			t.Y[ i * 2 + 1 ] = my;
			t.Position[ i * 2 + 1 ] = p;
			p += 62;
		}

		return( true );
	}

	public void draw()
	{
		if( X[ 0 ] < 0 ){
			return;
		}

		for( int i = 0; i < 12; i++ ){
			MyModel.mTUE[ "Train" ].draw( getX( i ), getY( i ), 4, getAngle( i ), 0, 0, 1 );
		}
	}

	public static void drawAll()
	{
		foreach( Train t in Obj ){
			t.draw();
		}
	}

	public void elapse()
	{
		if( X[ 0 ] < 0 ){
			return;
		}

		erasePrm();

		for( int i = Length * 2 - 1; i >= 0; i-- ){
			Position[ i ] -= Speed;
			if( Position[ i ] < 0 ){
				int		a = MyMap.getAngle( X[ i ], Y[ i ] );
				bool	pl = getPointLeft( i );
				int		nx = MyMap.getNextRailX( a, Reverse[ i ], pl );
				int		ny = MyMap.getNextRailY( a, Reverse[ i ], pl );
				int		na = MyMap.getAngle( X[ i ] + nx, Y[ i ] + ny );
				Reverse[ i ] = ( nx != -MyMap.getNextRailX( na, true ) ||
				                 ny != -MyMap.getNextRailY( na, true ) );
				X[ i ] += nx;
				Y[ i ] += ny;
				Position[ i ] += MyMap.getRailLength( na, getPointLeft( i ) );
			}
			MyMap.setPrm( X[ i ], Y[ i ], Idx );
		}
	}

	public static void elapseAll()
	{
		foreach( Train t in Obj ){
			t.elapse();
		}
	}

	public void erasePrm()
	{
		for( int i = Length * 2 - 1; i >= 0; i-- ){
			MyMap.setPrm( X[ i ], Y[ i ], -1 );
		}
	}

	public float getAngle( int idx )
	{
		return( (float)( Math.Atan(
		         ( getYw( idx * 2 + 1 ) - getYw( idx * 2 ) ) /
		         ( getXw( idx * 2 + 1 ) - getXw( idx * 2 ) ) ) * 180 / Math.PI ) );
	}

	public bool getPointLeft( int wi )
	{
		return( MyMap.getPointLeft( X[ wi ], Y[ wi ], 0 ) );
	}

	public float getX( int idx )
	{
		return( ( getXw( idx * 2 ) + getXw( idx * 2 + 1 ) ) / 2 );
	}

	public float getXw( int wi )
	{
		return( MyMap.getRailX( X[ wi ], Y[ wi ], Reverse[ wi ], getPointLeft( wi ), Position[ wi ] ) );
	}

	public float getY( int idx )
	{
		return( ( getYw( idx * 2 ) + getYw( idx * 2 + 1 ) ) / 2 );
	}

	public float getYw( int wi )
	{
		return( MyMap.getRailY( X[ wi ], Y[ wi ], Reverse[ wi ], getPointLeft( wi ), Position[ wi ] ) );
	}

	public static void remove( int idx )
	{
		Obj[ idx ].erasePrm();
		Obj[ idx ].X[ 0 ] = -1;
	}
}

class ETrain : TURetroGame, ITUChoose
{
	public static readonly int		CMD_LINE_LAYING  = 1;	//	H~
	public static readonly int		CMD_LINE_REMOVAL = 2;	//	HP
	public static readonly int		CMD_TRAIN_DEPLOY = 3;	//	Ԕzu
	public static readonly int		CMD_STATION_CONSTR = 4;	//	w

	static float		CenterX = 1600, CenterY = 1600;	//	ʒW
	static int			Count = 60 * 60 * 60 * 9;		//	oߎԁB9:00:00X^[g
	static float		Mag = 1.0f;		//	{
	static float		WorldX, WorldY;	//	[hW
	static bool			MoveCenter;		//	Wړw
	static bool			MoveMouse;		//	}EXړtO
	static int			StartX = -1, StartY;	//	n_
	static int			EndX, EndY;		//	I_
	static int[]		Plan;			//	v
	static bool			Perspective = true;	//	e
	static int			Speed;			//	Q[isx
	static bool			Stop;			//	Q[is~tO
	static bool			bRotate;		//	]tO
	static sbyte		Angle = -96;	//	_̊px
	static int			Command;		//	sR}h
	static TU2DButton	Btn0 = new TU2DButton( -58, 0, 11, 9, "߂", "BACK"    );	//	{^
	static TU2DButton	Btn1 = new TU2DButton( -46, 0, 11, 9, "~", "STOP"    );	//	{^
	static TU2DButton	Btn2 = new TU2DButton( -34, 0, 11, 9, "ᑬ", "SPD. DN" );	//	{^
	static TU2DButton	Btn3 = new TU2DButton( -22, 0, 11, 9, "", "SPD. UP" );	//	{^
	static TU2DButton	Btn4 = new TU2DButton( -10, 0, 11, 9, "ڍ", "REDUCT."  );	//	{^
	static TU2DButton	Btn5 = new TU2DButton(   2, 0, 11, 9, "L", "EXPANS."  );	//	{^
	static TU2DButton	Btn6 = new TU2DButton(  14, 0, 11, 9, "ؑ", "SWITCH"  );	//	{^
	static TU2DButton	Btn7 = new TU2DButton(  26, 0, 11, 9, "", "ROTAT.L" );	//	{^
	static TU2DButton	Btn8 = new TU2DButton(  38, 0, 11, 9, "E", "ROTAT.R" );	//	{^
	static TU2DButton	Btn10 = new TU2DButton( -10,  5, 20, 9, "H~", "LINE LAYING" );	//	{^
	static TU2DButton	Btn11 = new TU2DButton(  10,  5, 20, 9, "HP", "LINE REMOVAL" );	//	{^
	static TU2DButton	Btn12 = new TU2DButton( -10, -5, 20, 9, "Ԕzu", "TRAIN DEPLOY" );	//	{^
	static TU2DButton	Btn13 = new TU2DButton(  10, -5, 20, 9, "w"  , "STATION CONSTR." );	//	{^
	static TU2DButton	Btn20 = new TU2DButton( 0,  2, 20, 9, "߂", "NEW GAME" );	//	{^
	static TU2DButton	Btn21 = new TU2DButton( 0, -8, 20, 9, "", "CONTINUE" );	//	{^
	static TU2DWindow	WndTitle = new TU2DWindow( 0, 0, 0, 0 );	//	ʒu(0,0)A傫(0,0)̃_~[EBhE
	static TU2DWindow	WndMenu = new TU2DWindow( -40, 18, 45, 24 );	//	ʒu(-50,18)A傫(25,24)̃EBhE
	static TU2DWindow	WndFunction = new TU2DWindow( 0, -31, 0, 0 );	//	ʒu(0,-31)A傫(0,0)̃EBhE
	static TUDate		DT = new TUDate( 60, 1970, 1, 1, 0, 0, 0 );	//	1/60bPʁB1970/1/1 0:00:00

	public override void wmCreated()
	{
		SetStyle( System.Windows.Forms.ControlStyles.StandardDoubleClick, false );	//	_uNbN}

		Title = "Edɏ낤";
		MyMap.init( 2048, 2048 );
		MyModel.load();
		Btn0.setParent( WndFunction );
		Btn1.setParent( WndFunction );
		Btn2.setParent( WndFunction );
		Btn3.setParent( WndFunction );
		Btn4.setParent( WndFunction );
		Btn5.setParent( WndFunction );
		Btn6.setParent( WndFunction );
		Btn7.setParent( WndFunction );
		Btn8.setParent( WndFunction );
		Btn10.setParent( WndMenu );
		Btn11.setParent( WndMenu );
		Btn12.setParent( WndMenu );
		Btn13.setParent( WndMenu );
		Btn20.setParent( WndTitle );
		Btn21.setParent( WndTitle );
		WndTitle.add( new TU2DCharArray( -12,  24, "Edɏ낤" ) );
		WndTitle.add( new TU2DCharArray( -28,  18, "TAKE THE E-TRAIN" ) );
		WndTitle.add( new TU2DCharArray( -30, -20, "(c)2016 T.Umezawa" ) );
		Btn0.Choose = this;
		Btn1.Choose = this;
		Btn2.Choose = this;
		Btn3.Choose = this;
		Btn4.Choose = this;
		Btn5.Choose = this;
		Btn6.Choose = this;
		Btn7.Choose = this;
		Btn8.Choose = this;
		Btn10.Choose = this;
		Btn11.Choose = this;
		Btn12.Choose = this;
		Btn13.Choose = this;
		Btn20.Choose = this;
		Btn21.Choose = this;
		WndMenu.Margin = 1.0f;
		WndMenu.BorderWidth = 1.0f;
		WndMenu.Enable = false;
		DT.setFormat( "yyyy/MM/dd HH:mm:ss.ff" );	//	̏ݒ
		setFrameRate( 60 );
	}

	public override void wmMouseClickL( float x, float y )
	{
		if( MoveMouse ){
			MoveMouse = false;
			return;
		}

		int		cx = getCursorX();
		int		cy = getCursorY();
		short	p = MyMap.getPrm( cx, cy );

		if( Command == 0 ){
			int		t = MyMap.getType( cx, cy );
			if( t == MyMap.EKISYA ){
				Station.mObj[ p ].addPlatform();
				return;
			}
			if( p >= 0 ){
				Train.remove( p );
			}
			return;
		}

		if( Command == CMD_TRAIN_DEPLOY ){	//	Ԕzu
			Train.deploy( cx, cy );
			return;
		}

		if( Command == CMD_STATION_CONSTR ){	//	w
			Station.add( cx, cy );
			return;
		}

		if( StartX < 0 ){
			StartX = EndX = getCursorX();
			StartY = EndY = getCursorY();
			return;
		}

		if( Command == CMD_LINE_LAYING ){
			if( Plan == null ){
				return;
			}

			if( Plan[ Plan.Length - 4 ] < -1 ){
				return;
			}

			int		i = MyMap.setRail( Plan );
			EndX = Plan[ i * 4 - 4 ];
			EndY = Plan[ i * 4 - 3 ];
		}else{
			for( int my = StartY; ; my += Math.Sign( EndY - StartY ) ){
				for( int mx = StartX; ; mx += Math.Sign( EndX - StartX ) ){
					if( MyMap.getType( mx, my ) == MyMap.RAIL ){
						MyMap.set( mx, my, MyMap.JISYA, 0 );
					}
					if( mx == EndX )	break;
				}
				if( my == EndY )	break;
			}
		}

		CenterX += ( EndX - StartX ) * 100;
		CenterY += ( EndY - StartY ) * 100;
		StartX = EndX;
		StartY = EndY;
	}

	public override void onMouseClickR( int x, int y )
	{
		back();
	}

	public override void onMouseWheel( int d )
	{
		Mag += d / 4.0f;
		if( Mag < 0.5f )	Mag = 0.5f;
		if( Mag > 2.0f )	Mag = 2.0f;
		MoveCenter = true;		//	Wړw
	}

	public override void wmTimer()
	{
		if( Btn7.isDown() ){
			Angle++;
			bRotate = true;
		}
		if( Btn8.isDown() ){
			Angle--;
			bRotate = true;
		}

		//	f̃n{eôh߁Apx𐧌
		if( Angle < -96 )	Angle = -96;
		if( Angle > -64 )	Angle = -64;

		if( Stop ){
			return;
		}

		for( int i = (int)Math.Pow( 2, Speed ); i > 0; i-- ){
			elapse();
		}

		Invalidate();	//	ĕ`˗
	}

	public override void wmDraw()
	{
		GL1.Clear(					//	ʃNA
		 GL1._DEPTH_BUFFER_BIT |	//	[xobt@
		 GL1._COLOR_BUFFER_BIT );	//	Fobt@

		if( WndTitle.draw() )	return;

		GL1.MatrixMode( GL1._PROJECTION );	//	ˉeϊ̐ݒ胂[hɐ؂ւ
		GL1.PushMatrix();			//	}gbNXX^bNɊi[
		GL1.LoadIdentity();			//	ftHg̃}gbNXǂݍ

		float	m = 0.0453f * Mag;
		if( Perspective ){
			//	eɐݒ
			GL1.Frustum( getWidthf(), getHeightf(), 270, 14000 );
			GL1.Enable( GL1._LIGHTING );	//	CeBOL
			GL1.Enable( GL1._LIGHT0 );		//	0L
			GL1.Enable( GL1._COLOR_MATERIAL );	//	ގݒFōsȂ[hɂ
			GL1.EnableClientState( GL1._NORMAL_ARRAY );	//	@z񃂁[hɐݒ
			TUPrimitive.bNormal = true;		//	@𗘗p
		}else{
			//	seɐݒ
			GL1.Ortho( getWidthf() / m, getHeightf() / m, 0, 13000 );
		}

		GL1.MatrixMode( GL1._MODELVIEW );	//	fr[ϊ̐ݒ胂[hɐ؂ւ

		GL1.LoadIdentity();			//	ftHg̃}gbNXǂݍ
		GL1.LookAt(					//	_ݒ
		(float)Math.Cos( Angle * Math.PI / 0x80 ) * 200 / m,					//	J̈ʒuX
		(float)Math.Sin( Angle * Math.PI / 0x80 ) * 200 / m,					//	J̈ʒuY
		115.6f / m,					//	J̈ʒuZ
		   0,   0,  0,				//	Jʂ̒
		   0,   0,  1 );			//	J̌

		if( Perspective ){			//	ȅꍇ
			float	red   = 0.5f;		//	̐Ԑ
			float	green = 0.5f;		//	̗ΐ
			float	blue  = 0.5f;		//	̐

			float	ta = Count % ( 60 * 60 * 60 * 24 ) / ( 60 * 60 * 4.0f );	//	124Ԃ0`360̒lցB1=15B4=1
			if( ta < 6 * 15 ){	//	6Ȍꍇ
				red -= ( 6 * 15 - ta ) / 60;
				green -= ( 6 * 15 - ta ) / 60;
			}
			if( ta > 17 * 15 ){	//	17߂ꍇ
				red -= ( ta - 17 * 15 ) / 60;
			}
			if( ta > 16 * 15 ){	//	16߂ꍇ
				green -= ( ta - 16 * 15 ) / 60;
			}
			if( red < 0 )	red = 0;
			if( green < 0 )	green = 0;

			float[]	amb = { red, green, blue, 1.0f };
			GL1.Lightfv( GL1._LIGHT0, GL1._AMBIENT, amb );	//	

			float	s = 0.0f;
			if( ta > 90 && ta < 270 ){	//	6`18̏ꍇ
				double	r = ( ta - 90 ) / 180 * Math.PI;	//	WA
				s = (float)Math.Sin( r );
				float[]	pos = { (float)Math.Cos( r ) * 2, -1, s * 2, 0 };	//	W(-1,-4,3)̎wIȌ
				GL1.Lightfv( GL1._LIGHT0, GL1._POSITION, pos );	//	0̈ʒuݒ
			}
			float[]	dif = { s * red, s * green, s * blue, 1.0f };
			GL1.Lightfv( GL1._LIGHT0, GL1._DIFFUSE, dif );	//	gU
		}

		GL1.Enable( GL1._DEPTH_TEST );	//	[xeXgL
		GL1.EnableClientState( GL1._COLOR_ARRAY );	//	FzL
//		GL1.Scale( 0.0453f * Mag );	//	XP[ύXBglScalef( 0.0453f, 0.0453f, 0.0453f );

		GL1.Translatef( -CenterX, -CenterY, 0 );	//	sړ

//		float[]	xyz = GL1.UnProject( MouseX, getHeight() - MouseY - 1 );
//		float[]	xyz = UnProjectMouse();	//	}EXW gluUnProject Ăяo
		UnProjectMouse( 0 );	//	}EXʒu ZW 0 ̃[hW擾Bʂ̓oϐ MouseW Ɋi[B
		if( ( MouseL | MoveCenter ) && !bRotate ){		//	}EX{^A͒Wړw̏ꍇ
			float	dx = WorldX - MouseW[ 0 ];
			float	dy = WorldY - MouseW[ 1 ];
			if( dx != 0.0f || dy != 0.0f ){
				if( !MoveCenter ){
					MoveMouse = true;
				}
				CenterX += dx;
				CenterY += dy;
				GL1.Translatef( -dx, -dy, 0 );	//	sړ
			}
			MoveCenter = false;
		}else{
			bRotate = false;
			WorldX = MouseW[ 0 ];	//	}EXʒu ZW 0 ̃[hWXێĂB
			WorldY = MouseW[ 1 ];	//	}EXʒu ZW 0 ̃[hWYێĂB
		}

		MyMap.draw( (int)( CenterX / 100 ), (int)( CenterY / 100 ), (int)( 24 / Mag ) );			//	`

		Train.drawAll();		//	Ԃ`

		GL1.Disable( GL1._LIGHTING );	//	CeBO𖳌
		GL1.Disable( GL1._COLOR_MATERIAL );	//	ގݒFōsȂ[h𖳌
		GL1.DisableClientState( GL1._NORMAL_ARRAY );	//	@z񃂁[h
		TUPrimitive.bNormal = false;		//	@𗘗pȂ

		//	J[\`
		if( Command != 0 ){
			MyModel.mTUE[ "Cursor" ].draw( getCursorX() * 100, getCursorY() * 100, 0 );
		}

		GL1.DisableClientState( GL1._COLOR_ARRAY );	//	Fz𖳌
		GL1.Disable( GL1._DEPTH_TEST );

		//	v`
		if( StartX >= 0 ){
			if( Command == CMD_LINE_LAYING ){
				if( EndX != getCursorX() || EndY != getCursorY() ){
					EndX = getCursorX();
					EndY = getCursorY();
					Plan = MyMap.createRail( StartX, StartY, EndX, EndY );
				}
				if( Plan != null ){
					if( Plan[ Plan.Length - 4 ] < -1 ){
						GL1.Color4( 0xffff0000 );
					}else{
						GL1.Color4( 0xffffff00 );
					}
					TUPrimitive.bColor = false;
					MyModel.drawRail( Plan );
					TUPrimitive.bColor = true;
				}
			}else{
				EndX = getCursorX();
				EndY = getCursorY();
				for( int my = StartY; ; my += Math.Sign( EndY - StartY ) ){
					for( int mx = StartX; ; mx += Math.Sign( EndX - StartX ) ){
						if( MyMap.getType( mx, my ) == MyMap.RAIL ){
							GL1.Color4ABGR( 0x550000ff );
						}else{
							GL1.Color4ABGR( 0x2200ffff );
						}
						TUPrimitive.bColor = false;
						MyModel.mTUE[ "Cursor" ].draw( mx * 100, my * 100, 0 );
						TUPrimitive.bColor = true;
						if( mx == EndX )	break;
					}
					if( my == EndY )	break;
				}
			}
		}

		GL1.MatrixMode( GL1._PROJECTION );	//	ˉeϊ̐ݒ胂[hɐ؂ւ
		GL1.PopMatrix();			//	}gbNXX^bNo
		GL1.MatrixMode( GL1._MODELVIEW );	//	fr[ϊ̐ݒ胂[hɐ؂ւ
		GL1.LoadIdentity();				//	ftHg̃}gbNXǂݍ

		DT.set( Count );	//	oߎԂݒ
		draw( DT.toString(), -63, 35 );

		WndMenu.draw();
		WndFunction.draw();
	}

	public void back()
	{
		if( StartX >= 0 ){
			StartX = -1;
			Plan = null;
			return;
		}

		Command = 0;
		WndMenu.Enable ^= true;
	}

	public bool choose( Object obj )
	{
		if( obj == Btn0 ){	//	߂
			back();
		}
		if( obj == Btn1 ){	//	~
			Stop ^= true;
		}
		if( obj == Btn2 ){	//	ᑬ
			Speed--;
		}
		if( obj == Btn3 ){	//	
			Speed++;
		}
		if( obj == Btn4 ){	//	ڍ
			onMouseWheel( 1 );
		}
		if( obj == Btn5 ){	//	L
			onMouseWheel( -1 );
		}
		if( obj == Btn6 ){	//	ؑ
			Perspective ^= true;
		}

		if( obj == Btn10 ){	//	H~
			Command = CMD_LINE_LAYING;
			WndMenu.Enable = false;
		}
		if( obj == Btn11 ){	//	HP
			Command = CMD_LINE_REMOVAL;
			WndMenu.Enable = false;
		}
		if( obj == Btn12 ){	//	Ԕzu
			Command = CMD_TRAIN_DEPLOY;
			WndMenu.Enable = false;
		}
		if( obj == Btn13 ){	//	w
			Command = CMD_STATION_CONSTR;
			WndMenu.Enable = false;
		}

		if( obj == Btn20 ){	//	߂
			WndTitle.Enable = false;
		}

		return( true );
	}

	static void elapse()
	{
		Count++;
		Train.elapseAll();
	}

	static int getCursorX()
	{
		return( ( (int)WorldX + 50 ) / 100 );
	}

	static int getCursorY()
	{
		return( ( (int)WorldY + 50 ) / 100 );
	}

	static void Main()
	{
		new ETrain();
	}
}
